unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, CPortCtl, CPort, Menus, ComCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    ComPort: TComPort;
    ComLed1: TComLed;
    MainMenu1: TMainMenu;
    Failas1: TMenuItem;
    Ieiti1: TMenuItem;
    Nustatymai1: TMenuItem;
    RS2321: TMenuItem;
    Prisijungti1: TMenuItem;
    Memo1: TMemo;
    Button2: TButton;
    Edit2: TEdit;
    ComTerminal1: TComTerminal;
    Button5: TButton;
    Button6: TButton;
    GroupBox3: TGroupBox;
    GroupBox4: TGroupBox;
    GroupBox5: TGroupBox;
    GroupBox6: TGroupBox;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    GroupBox8: TGroupBox;
    GroupBox9: TGroupBox;
    GroupBox10: TGroupBox;
    Button7: TButton;
    GroupBox7: TGroupBox;
    Button8: TButton;
    ComLed3: TComLed;
    ComLed4: TComLed;
    GroupBox11: TGroupBox;
    GroupBox12: TGroupBox;
    Button9: TButton;
    Button10: TButton;
    Button11: TButton;
    Button12: TButton;
    Button13: TButton;
    Button14: TButton;
    Button15: TButton;
    Panel1: TPanel;
    Label35: TLabel;
    Label37: TLabel;
    Label39: TLabel;
    Label40: TLabel;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    procedure RS2321Click(Sender: TObject);
    procedure ComPortAfterOpen(Sender: TObject);
    procedure ComPortAfterClose(Sender: TObject);
    procedure Prisijungti1Click(Sender: TObject);
    procedure Ieiti1Click(Sender: TObject);
    function ComPortRxChar:integer;
    procedure Button2Click(Sender: TObject);
    procedure Siusti(str:string);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Komandos(raide:string);
    procedure SplitLine(const Delimiter: Char; Input: string; const Strings: TStrings; trint:bool);
    procedure Formuoti(const Strings: TStrings);
    function VerstiBitus(nI:integer; nK:integer):string;
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Stop(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure moveForward(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure moveBackwards(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure moveLeft(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure moveRight(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button13Click(Sender: TObject);
    procedure Button14Click(Sender: TObject);
    procedure Button15Click(Sender: TObject);
  private
    { Private declarations }
  public
    nLaukti: Integer;
    lConsole: bool;
    aKomandos:array of string;
    aLaukimai:array of integer;
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.RS2321Click(Sender: TObject);
begin
  ComPort.ShowSetupDialog;
end;

procedure TForm1.ComPortAfterOpen(Sender: TObject);
  var str:string;
begin
  MainMenu1.Items[1][0].Enabled := False;
  ComPort.ReadStr(str, ComPort.InputCount);
  if not lConsole then
  begin
    MainMenu1.Items[1][1].Caption := 'Disconnect ROOMBA';
    Button7.Caption := 'Disconnect ROOMBA';
    Button2.Enabled := true;
    Button8.Enabled := true;
    Button9.Enabled := true;
    Button10.Enabled := true;
    Button11.Enabled := true;
    Button12.Enabled := true;
    Button13.Enabled := true;
    Button14.Enabled := true;
    Button15.Enabled := true;
    Edit2.Enabled := true;
    Button5.Enabled := false;
    Siusti(#128);
        Siusti(#130);///////////////////////////////////////////////////////////////
    Siusti(#131);
    Siusti(#139);
    Siusti(#0);
    Siusti(#255);
    Siusti(#255);
  end
  else
  begin
    Button5.Caption := 'Disconnect Console';
    MainMenu1.Items[1][1].Enabled := False;
    ComTerminal1.Enabled := true;
  end;
  //ComPort.ClearBuffer(true, true);
end;

procedure TForm1.ComPortAfterClose(Sender: TObject);
begin
  MainMenu1.Items[1][1].Caption := 'Connect ROOMBA';
  MainMenu1.Items[1][0].Enabled := True;
  Button7.Caption := 'Connect ROOMBA';
  Button2.Enabled := false;
  Button8.Enabled := false;
  Button9.Enabled := false;
  Button10.Enabled := false;
  Button11.Enabled := false;
  Button12.Enabled := false;
  Button13.Enabled := false;
  Button14.Enabled := false;
  Button15.Enabled := false;
  ComTerminal1.Enabled := false;
  Edit2.Enabled := false;
  Button5.Enabled := true;
  lConsole := false;
end;

procedure TForm1.Prisijungti1Click(Sender: TObject);
begin
  if ComPort.Connected then
    ComPort.Close
  else
    ComPort.Open;
end;

procedure TForm1.Ieiti1Click(Sender: TObject);
begin
  if ComPort.Connected then
    ComPort.Close;
  sleep(1000);
  Form1.Close;
end;



procedure TForm1.Siusti(Str: string);
  var i: integer;
begin
if ComPort.Connected then begin
    i := ComPort.WriteStr(str);
    Memo1.Text:= Memo1.Text + '<< ' + Str + ' ' + IntToStr(i) + #13#10;
  end;
  Memo1.Text:= Memo1.Text + '____' + #13#10;
  Memo1.Repaint;
  Memo1.SelStart := length(memo1.Text);
  Memo1.SelLength := 0;
end;



function TForm1.ComPortRxChar:integer;
  var str: string;
    i, nI: integer;
begin
  ComPortRxChar := 0;
  if ComPort.Connected then begin
    i := 0;
    while (ComPort.InputCount < nLaukti) and (i < 10000) do begin
      sleep(1);
      inc(i);
    end;
    //if (ComPort.InputCount >= nLaukti) then begin
      ComPort.ReadStr(Str, nLaukti);
      //Memo1.Text := Memo1.Text + '>> ';
      nI := 0;
      for i := 1 to nLaukti do begin
        //Memo1.Text := Memo1.Text + IntToStr(ord(str[i])) + ' ';
        nI := nI SHL 8 + ord(str[i]);
      end;
      ComPortRxChar := nI;
      //Memo1.Text := Memo1.Text + ' = ' + IntToStr(nI) + ' - count - ' + IntToStr(nLaukti) +#13#10;
      //Memo1.Text := Memo1.Text + Str;
      nLaukti := 0;
      //Memo1.Repaint;
      //Memo1.SelStart:=length(memo1.Text);
      //Memo1.SelLength:=0;
    //end;
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
  var zodis, raide, tmp: string;
    nLeftBegin, nRightBegin, nL, nR: word;
    i, j, k: integer;
begin
  zodis := Edit2.Text;
//////  Siusti(#128);
 //////         Siusti(#130);////////////////////////////////////////////////////////////////
/////  Siusti(#131);
  for i := 1 to length(zodis) do begin
    raide := zodis[i];
    Memo1.Text := Memo1.Text + raide + #13#10;
    aKomandos := nil;
    aLaukimai := nil;
    komandos(raide);
    for j := 0 to length(aKomandos)-1 do
    begin
      ComPort.ReadStr(tmp, ComPort.InputCount);
      ComPort.WriteStr(#149#2#43#44);//===========================================
      nLaukti := 2;
      nLeftBegin := ComPortRxChar;
      nLaukti := 2;
      nRightBegin := ComPortRxChar;
      k := aLaukimai[j];
      //nLeftEnd := nLeftEnd + aLaukimai[j];
      //nRightEnd := nRightEnd + aLaukimai[j];
      ComPort.WriteStr(aKomandos[j]);
      repeat begin
        ComPort.WriteStr(#149#2#43#44);
        nLaukti := 2;
        nL := ComPortRxChar - nLeftBegin;
        nLaukti := 2;
        nR := ComPortRxChar - nRightBegin;
      end;
      until (nL >= k) or (nR >= k);
      ComPort.WriteStr(aKomandos[j][1]+#0#0#0#0);
      Memo1.Text := Memo1.Text + raide + #13#10;
      Memo1.Repaint;
      Memo1.SelStart:=length(memo1.Text);
      Memo1.SelLength:=0;
    end;
  end;
  Siusti(#128);
end;

procedure TForm1.Komandos(raide: string);
  var data: TextFile;
  simb:char;
  eilute:string;
  rasta: bool;
//  i, j:integer;
  Arr: TStringList;
begin
  AssignFile(data, 'ABC.txt');
  ReSet(data);
  rasta := false;
  Arr := TStringList.Create;
  while (not Eof(data)) and (not rasta) do
  begin
    read(data, simb);
    readln(data, eilute);
    if simb = raide then
    begin
      rasta := true;
      SplitLine(';', eilute, Arr, true);
      Formuoti(Arr);
//      Memo1.Text := memo1.text + 'raides ' + inttostr(Arr.Count) + #13#10;
//      for i:=0 to Arr.Count-1 do Memo1.Text := memo1.text + ' > '+ Arr[i] + #13#10;
//      for i:=0 to length(aKomandos)-1 do Memo1.Text := memo1.text + ' > '+ aKomandos[i] + #13#10;
    end;
  end;
  Arr.Free;
  CloseFile(data);
end;

procedure TForm1.SplitLine(const Delimiter: Char; Input: string; const Strings: TStrings; trint:bool);
  //var i: integer;
begin
   Assert(Assigned(Strings)) ;
   Strings.Clear;
   Strings.Delimiter := Delimiter;
   Strings.DelimitedText := Input;
   if trint then
   begin
     Strings.Delete(0);
     Strings.Delete(Strings.Count - 1);
   end;
{  i := 0;
  while length(eile) > 0 do
  begin
    SetLength(arr, (Length(arr) + 1));
    arr[i] := AnsiLeftStr(simb, AnsiPos(simb, eile) - 1);
    inc(1);
    eile := AnsiMidStr(simb, AnsiPos(simb, eile) + 1);
  end;}
end;

procedure TForm1.Formuoti(const Strings: TStrings);
  var i, k:integer;
  Arr: TStringList;

begin
  Arr := TStringList.Create;
  for i := 0 to Strings.Count - 1 do
  begin
    if ((i+1) mod 2) = 1 then
    begin
      SetLength(aKomandos, Length(aKomandos) + 1);
      SplitLine(',', Strings[i], Arr, false);
      k := StrToInt(Arr[0]);
      aKomandos[Length(aKomandos) - 1] := Chr(k);
      case k of
        137: begin
              aKomandos[Length(aKomandos) - 1] := aKomandos[Length(aKomandos) - 1] +
                VerstiBitus(StrToInt(Arr[1]), 2) + VerstiBitus(StrToInt(Arr[2]), 2)
             end;
      end;
    end
    else begin
      SetLength(aLaukimai, Length(aLaukimai) + 1);
      aLaukimai[Length(aLaukimai) - 1] := StrToInt(Strings[i]);
    end;
  end;
end;

function TForm1.VerstiBitus(nI:integer; nK:integer):string;
  var i, j:integer;
  rez: string;
begin
  rez := '';
  for j := 1 to nK do
  begin
    i := nI and $FF;
    if i = 0 then
      rez := #0 + rez
    else
      rez := chr(i) + rez;
    nI := nI SHR 8
  end;
  VerstiBitus := rez;
end;



procedure TForm1.Button3Click(Sender: TObject);
begin
  Siusti(#128);
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  Siusti(#128);
          Siusti(#130);////////////////////////////////////////////////////////
  Siusti(#131);
end;


procedure TForm1.FormCreate(Sender: TObject);
begin
  nLaukti := 0;
  Button2.Enabled := false;
  Button8.Enabled := false;
  Button9.Enabled := false;
  Button10.Enabled := false;
  Button11.Enabled := false;
  Button12.Enabled := false;
  Button13.Enabled := false;
  Button14.Enabled := false;
  Button15.Enabled := false;
  ComTerminal1.Enabled := false;
  Edit2.Enabled := false;
  lConsole := false;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  if ComPort.Connected then
  begin
    Button7.Enabled := true;
    Button5.Caption := 'Connect Console';
    MainMenu1.Items[1][1].Enabled := True;
    ComPort.Close;
    ComTerminal1.ComPort := NIL;
  end
  else begin
    Button7.Enabled := false;
    lConsole := true;
    ComTerminal1.ComPort := ComPort;
    ComPort.Open;
  end;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
  ComPort.ShowSetupDialog;
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
  if ComPort.Connected then
  begin
    Siusti(#139);
    Siusti(#0);
    Siusti(#0);
    Siusti(#255);
    ComPort.Close;
  end
  else begin
    ComPort.Open;
  end;
end;

procedure TForm1.Button8Click(Sender: TObject);
begin
  Siusti(#128);
          Siusti(#130);///////////////////////////////////////////////////////////
  Siusti(#131);
  Siusti(#137);
  Siusti(#0);
  Siusti(#0);
  Siusti(#0);
  Siusti(#0);
  Siusti(#139);
  Siusti(#0);
  Siusti(#255);
  Siusti(#255);
end;

procedure TForm1.Stop(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Siusti(#137);
  Siusti(#0);
  Siusti(#0);
  Siusti(#0);
  Siusti(#0);
end;

procedure TForm1.moveForward(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Siusti(#137);
  Siusti(#1);
  Siusti(#44);
  Siusti(#127);
  Siusti(#255);
end;

procedure TForm1.moveBackwards(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Siusti(#137);
  Siusti(#254);
  Siusti(#212);
  Siusti(#127);
  Siusti(#255);
end;

procedure TForm1.moveLeft(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Siusti(#137);
  Siusti(#1);
  Siusti(#44);
  Siusti(#0);
  Siusti(#1);
end;

procedure TForm1.moveRight(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Siusti(#137);
  Siusti(#1);
  Siusti(#44);
  Siusti(#255);
  Siusti(#255);
end;

procedure TForm1.Button13Click(Sender: TObject);
begin
  Siusti(#134);
end;

procedure TForm1.Button14Click(Sender: TObject);
begin
  Siusti(#135);
end;

procedure TForm1.Button15Click(Sender: TObject);
begin
  Siusti(#136);
end;

end.

